#!/usr/bin/env python
# !-*- coding: utf-8 -*-
from itertools import islice
import sys
import re
import gzip

#python lineage_barcode.py tccscR_1 tccscR_1_R1.fastq.gz tccscR_1_R2.fastq.gz human
#python lineage_barcode.py tccscR_2 tccscR_2_R1.fastq.gz tccscR_2_R2.fastq.gz human
#python lineage_barcode.py tccscR_3 tccscR_3_R1.fastq.gz tccscR_3_R2.fastq.gz human
#python lineage_barcode.py tccscR_4 tccscR_4_R1.fastq.gz tccscR_4_R2.fastq.gz human

#####R1:cell_barcode(16)+UMI(12)
#####R2:read(150),contains lineage_barcode

dir = './'
basedir = dir
fdir = dir +sys.argv[1]+'/'
sample=sys.argv[1]
file1=sys.argv[2]
file2=sys.argv[3]
sp=sys.argv[4]

fin1=open(basedir+file1)#R1
fout=open(fdir+sp+'_all_barcode.txt','w')
print("complete_read\tcomplete_lineage_bc\treal_lineage_bc\tuni_id\tcell_bc_UMI",file=fout)


#R1 barcode+UMI
readid={}
umiid={}
flag=0
id=''
seq=''

n_id=0
for line1 in fin1:
    line1 = line1.strip('\n')
    if '@' in line1:
        flag = 1
        a = line1.split(' ')
        n_id=n_id+1
        print(n_id,a[0])
    elif flag == 1 and '+' not in line1 and 'F' not in line1:
        seq = line1
        readid[n_id]=seq
        flag = 0
        seq = ''
fin1.close()

flag2=0
id2=''
seq2=''
mapbc=''
mapumi=''

fin2=open(basedir+file2)#R2
bc_pattern=r'agagaccata(\w+)cgatatcgcc'

n_id2=0
for line2 in fin2:
    line2 = line2.strip('\n')
    if '@' in line2:
        flag2 = 1
        a = line2.split(' ')
        n_id2=n_id2+1
        mapbc = readid[n_id2]
    elif flag2 == 1 and '+' not in line2 and 'F' not in line2:
        seq2 = line2
        c = re.search(bc_pattern, seq2, re.I)
        if c:
            if 50 <= len(c.group(1)) <= 55:
                real_bc = c.group(1)[2:42]
                print(seq2 + '\t' + c.group(1) + '\t' + real_bc + '\t' + str(n_id2) + '\t' + mapbc, file=fout)
        flag2 = 0
        seq2 = ''
        mapbc = ''
        mapumi = ''

fin2.close()
fout.close()
